%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Zs
% @cels{1} = tmp1
% @cels{2} = tmp2
% @cels{3} = tmp3
% ŁCtmp1~3 tmp1.a  tmp1.b 
% \̂łƂD̂Ƃ
%
% acxNgi܂̓XJ[j
%   t_cell(cels, 'a') = [tmp1.a, tmp2.a, tmp3.a]
% axNg
%   t_cell(cels, 'a') = [tmp1.a; tmp2.a; tmp3.a]
%
% tB[h'a','b'́CxNg܂ŋ
%
% Zs
% @cels{1,1} = tmp1  cels{1,2} = tmp4
% @cels{2,1} = tmp2  cels{2,2} = tmp5
% @cels{3,1} = tmp3  cels{3,2} = tmp6
% ŁCtmp1~3 tmp~.a \̂łƂD̂Ƃ
%
% t_cell(cels, 'a') = [tmp1.a, tmp4.a]
%                     [tmp2.a, tmp5.a]
%                     [tmp3.a, tmp6.a]
% Z̏ꍇCtB[h'a'́CXJ[̂݋
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ret = t_cell(cels,fld,varargin)

if(length(varargin) == 0)
  t = size(cels); ln = length(t); %ln ͎
else
  error('# of input is should be 2.');
end

if(ln == 1)
  tmp1 = length(getfield(cels{1}, fld));
  if(tmp1 >= 1 & size(getfield(cels{1}, fld),2) == 1)
    ret = zeros(tmp1, t);
    for lp=1:t
      ret(:,lp) = getfield(cels{lp}, fld);
    end
  elseif(tmp1 >= 1 & size(getfield(cels{1}, fld),1) == 1)
    ret = zeros(t, tmp1);
    for lp=1:t
      ret(lp,:) = getfield(cels{lp}, fld);
    end
  else
    error('vector(incl. scalar) field is allowed.');
  end
  
elseif(ln == 2)
  if(isscalar(getfield(cels{1}, fld)) == 1)
    ret = zeros(t);
    for k1=1:t(1)
      for k2=1:t(2)
	ret(k1,k2) = getfield(cels{k1,k2}, fld);
      end
    end
  else
    error('indicated field must be scalar (if the cell has multi-dimensional)');
  end
end

